import numpy as np
from sklearn.datasets import make_blobs
import matplotlib.pyplot as plt

# sklearn.datasets.make_blobs = make_blobs(n_samples=100, n_features=2, *, centers=None, cluster_std=1.0, 
# center_box=(-10.0, 10.0), shuffle=True, random_state=None, return_centers=False)
#     Generate isotropic Gaussian blobs for clustering.

X, y = make_blobs( n_samples=20, centers=2,  random_state=2 )
print( X.shape )
print( y.shape )


fig, ax = plt.subplots( )

ax.set_aspect( 1 )
ax.scatter( X[:,0], X[:,1], c=y )

plt.show( )

y = y.reshape( (-1,1) )

A = np.concatenate( (X, y), axis=1 )
print( A.shape )

np.savetxt( "datos.csv", A, delimiter=',' ) 
