import numpy as np
import matplotlib.pyplot as plt
import matplotlib.tri as tri

A = np.genfromtxt( "datos.csv", delimiter=',', dtype=float )

X = A[:,0:2]
y = A[:,2]
print( X.shape )
print( y.shape )

# El modelo de la máquina de vectores
# de soporte
# https://scikit-learn.org/stable/modules/svm.html#mathematical-formulation
#   mvs.dual_coef_
#   mvs.support_
#   mvs.intercept_

yalpha = np.array( [-0.08568314,  0.08568314] )

svec = np.array( [[-0.72864791, -7.18926735],
                  [ 0.35559455, -2.48116443]] )
b = 1.96787909

# Para la línea de la función de decisión
k1 = yalpha[0]*svec[0,1] + yalpha[1]*svec[1,1]
k2 = yalpha[0]*svec[0,0] + yalpha[1]*svec[1,0]

print( svec[0] )
print( svec[1] )
def decision( x ) :
	return yalpha[0]*(svec[0] @ x) + yalpha[1]*(svec[1] @ x) + b  

vv = np.zeros( (2,1) )
z = decision( vv )
print( z[0] )
vv[1,0] = -10
z = decision( vv )
print( z[0] )

fig, ax = plt.subplots()
ax.set_aspect( 1 )

# Create grid values first.
n = 20
xi = np.linspace(-5,  3, n)
yi = np.linspace(-11, 1, n)
vx, vy = np.meshgrid( xi, yi )

zi = np.zeros( (n,n) )
i = 0
while i < n :
	vv[1,0] = yi[i]
	j = 0
	while j < n :
		vv[0,0] = xi[j]
		v = decision( vv ) 
		zi[i,j] = v[0] 
		## if v[0] >= 0 :
		## 	zi[i,j] = 1 
		## else :
		## 	zi[i,j] = -1 
		j += 1
	i += 1

# Linearly interpolate the data (x, y) on a grid defined by (xi, yi).

ax.set_xlim( (-5,3) )
ax.set_ylim( (-11,1) )

# Para poner la escala del color:
cntr = ax.contourf(vx, vy, zi )
fig.colorbar(cntr, ax=ax)

# Los puntos
ax.scatter( X[:,0], X[:,1], c=y )

# Los vectores de soporte en rojo
ax.scatter( svec[:,0], svec[:,1], c='red' )

# Para la línea de la función de desición
yy = (-b - k2*xi)/k1
ax.plot(xi, yy, linewidth=4, c='black')

plt.show( )
